<?php

/**
 * inf_radicado actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_radicado
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_radicadoActions extends sfQuery {
    /*
     * Se deja de usar la función executeList de arriba y se extiende esta clase del manejador de consultas sfQuery
     * Oscar Acero - 19092016  
     */

    /*
     * ------VARIABLES PARA SERVICIOS DE CONSULTA - LIST ---------------
     */

    protected $table_names = array(
        'CBR_REMISION_TITULO',
        'CBR_PAR',
        'CBR_REMISION_TIT_AGRUP_V',
        'CBR_APRUEBA_REPARTO_ULT_V',
        'CBR_APROB_DENEG_ULT_V',
        'CBR_ABOGADO_ULT_V',
        'CBR_PROCESO_COACTIVO',
        'CBR_RESOL_TIT_REMIS_V',
        'CBR_REMISION_TITULO_DET_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_PAR' =>
        array(
            'id_par' => 'CBR_REMISION_TITULO'
        ),
        'CBR_REMISION_TIT_AGRUP_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_APRUEBA_REPARTO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_APROB_DENEG_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ABOGADO_ULT_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )/* ,
          'CBR_PROCESO_COACTIVO,LEFT' =>
          array(
          'id_remision_titulo' => 'CBR_REMISION_TITULO'
          ) */,
        'CBR_RESOL_TIT_REMIS_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_REMISION_TITULO_DET_V,LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'fecha_remision' => 'fecha_remision',
            'id_par' => 'id_par',
            'no_folios' => 'no_folios',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'numero_remision,||, - ,||,anho_remision' => 'completo_remision'
        ),
        'CBR_REMISION_TIT_AGRUP_V' =>
        array(
            'cod_titulo_det_agrup' => 'cod_titulo_det_agrup',
            'observaciones_det_agrup' => 'observaciones_det_agrup',
            'mineral_det_agrup' => 'mineral_det_agrup'
        ),
        'CBR_PAR' =>
        array(
            'descripcion' => 'descripcion_par'
        ),
        'CBR_APRUEBA_REPARTO_ULT_V' =>
        array(
            'aprobado' => 'aprobado_rep'
        ),
        'CBR_APROB_DENEG_ULT_V' =>
        array(
            'aprobado' => 'aprobado_deneg'
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => 'id_abogado',
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc'
        )/* ,
          'CBR_PROCESO_COACTIVO' =>
          array(
          'id_proceso_coactivo' => 'id_proceso_coactivo',
          'no_proceso' => 'no_proceso',
          'id_anhos' => 'id_anhos_proceso_coa',
          'fecha' => 'fecha_proceso_coa'
          ) */,
        'CBR_RESOL_TIT_REMIS_V' =>
        array(
            'no_resolucion' => 'no_resolucion',
            'date_expedicion' => 'date_expedicion',
            'no_resolucion_det' => 'no_resolucion_det',
            'date_expedicion_det' => 'date_expedicion_det',
            'no_resolucion_text' => 'no_resolucion_text',
            'date_expedicion_text' => 'date_expedicion_text',
            'no_resolucion_text_completa' => 'no_resolucion_text_completa',
            'valor_capital' => 'valor_capital',
            'valor_interes' => 'valor_interes',
            'valor_abono' => 'valor_abono',
            'saldo' => 'saldo',
            'valor_abono_calc' => 'valor_abono_calc',
            'valor_acuerdo' => 'valor_acuerdo',
            'valor_embargo' => 'valor_embargo'
        )
    ); //por cada tabla especificar los campos del select
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'anho_remision', 'numero_remision', 'id_remision_titulo'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo,a' => array('!=' => array(-1)),
            'id_remision_titulo,b' => array('=' => array('id_remision_titulo')),
            'id_par' => array('=' => array('id_par')),
            'estado' => array('=' => array('estado')),
            'numero_remision' => array('=' => array('numero_remision')),
            'anho_remision' => array('=' => array('anho_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            'no_folios' => array('=' => array('no_folios')),
            'fecha_remision' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('=' => array('num_doc'))
        ),
        'CBR_REMISION_TITULO_DET_V' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    protected function validateRemove(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    // Cambiar nombre executeList2 a executeList si se quiere volver a usar esta función. 
    public function executeList2(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejar Errores
         */
        try {

            /*
             * Variables para el registro de log
             */

            //1 - indica operacion de consulta
            $id_ope_bd = 1;

            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_debito_ref');


            //CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, $observacion);

            /*
             * Filtro para que levante por CO_ESTUDIOS_PREVIOS y por FASE
             */

            $where = "";
            $whereTituloMinero = "";
            $whereAbogado = "";
            $wherePar = "";

            if (isset($request['id_par'])) {
                $wherePar = " AND tab0.id_par=" . $request['id_par'];
            }

            if (isset($request['cod_titulo'])) {
                $whereTituloMinero .= " AND tab0.cod_titulo='" . $request['cod_titulo'] . "'";
            }

            //$id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */
            $sql = <<<EOD
    select tab0.*
    from(
        select 
            tab0.numero_remision,
            tab0.numero_correpondencia,
            tab0.anho_remision, 
            tab0.fecha_remision,
            tab0.id_par,
            tab0.cod_titulo,
            v0.MINERAL,
            tab0.no_folios,
            tab1.descripcion AS PAR,
            tab0.cod_titulo AS TITULO,
            tab0.estado

        from cbr_remision_titulo tab0
        left join cbr_par tab1 ON tab1.id_par = tab0.id_par
        left join cbr_titulo_minero_v v0  ON v0.COD_TITULO = tab0.cod_titulo
    )tab0

    where tab0.fecha_remision BETWEEN 
        TO_DATE('$fecha_ini', 'YYYY-MM-DD') AND 
        TO_DATE('$fecha_fin', 'YYYY-MM-DD')
    $wherePar $whereTituloMinero                  
    ORDER BY tab0.par, tab0.numero_remision, tab0.numero_correpondencia

EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Ejecuta sql
            $this->totalRows = count($records);
            $this->list_data = $records;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
